#include "header.h"



/*------------------------------------------------------------------------------*/
/*             Script traitant les ventuelles erreurs de if/while              */
/*------------------------------------------------------------------------------*/

int checkTest(int nbLignes, char ScNom[50]) {

FILE *fLog;
int k, l, m, test, debut, fin, somme=0, SizeLigne, var, lignesBegin[5000], lignesEnd[5000], lignesIf[5000], lignesEndif[5000], lignesElse[5000], lignesElseif[5000], blocTests[5000];
char c, *ligne, *ligneCode, cInt[7];
ERREUR err;

fLog = fopen("DbTempTES4", "ab");
if ( fLog == NULL ) {
   return 10;
}



strDetectTest(lignesIf, nbLignes, ScNom, "if");
strDetectTest(lignesEndif, nbLignes, ScNom, "endif");
strDetectTest(lignesElse, nbLignes, ScNom, "else");
strDetectTest(lignesElseif, nbLignes, ScNom, "elseif");
strDetectTest(lignesBegin, nbLignes, ScNom, "begin");
strDetectTest(lignesEnd, nbLignes, ScNom, "end");

for ( k = 0; k < nbLignes; k++ ) {
    if ( lignesEnd[k] != 0 ) {
         if ( lignesEndif[k] != 0 ) lignesEnd[k] = 0;
    }
}

/* Recherche des erreurs d'enchanement de test : dtection des end en trop */
var = 0;
blocTests[0] = lignesBegin[0] - lignesEnd[0];

for ( k = 1; k < nbLignes; k++ ) {
    blocTests[k] = blocTests[k-1] + lignesBegin[k] - lignesEnd[k];
    if ( ( blocTests[k] > 1 ) && ( var == 0 ) ) {
         err.ligneErr = -1;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : erreur, des blocs Begin/End ne peuvent tre imbriqus !");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         var = 1;
    }
    if ( blocTests[k] <= 1 ) var = 0;
}

for ( k = 1; k < nbLignes; k++ ) {
    if ( blocTests[k] < 0 ) {
       err.ligneErr = k;
       err.niveau = 2;
       /* Dtection du bloc begin/end "matre" prcdent */
       debut = 0;
       fin = k;
       l = k-1;
       test = 0;
       while ( test == 0 ) {
             l--;
             if ( l < 0 ) test = 2;
             else {
                  if ( blocTests[l] == 0 ) {
                     test = 1;
                     debut = l+1;
                  }
             }
       }
       /* Copie de l'erreur dans le log d'erreur */
       debut++;
       fin++;
       strcpy(err.messageErr, "    - Ligne ");
       int2str(&(cInt[0]), fin);
       strcat(err.messageErr, cInt);
       strcat(err.messageErr, " : un 'end' en trop ");
       if ( test == 2 ) strcat(err.messageErr, "(pas de 'begin' avant le 'end').");
       else {
            strcat(err.messageErr, "(l'erreur a probablement t faite entre la ligne ");
            int2str(&(cInt[0]), debut);
            strcat(err.messageErr, cInt);
            strcat(err.messageErr, " et la ligne ");
            int2str(&(cInt[0]), fin);
            strcat(err.messageErr, cInt);
            strcat(err.messageErr, ").");
       }
       fwrite(&err, sizeof(ERREUR), 1, fLog);
       /* Ajout de 1  toutes les valeurs de blocTests aprs k pour annuler l'effet du end de trop */
       for (l = k+1; l < nbLignes; l++) {
           blocTests[l] = blocTests[l]+1;
       }
    }
}


/* Recherche des erreurs d'enchanement de test : dtection des Begin en trop */
for ( k = 0; k < nbLignes; k++ ) {
    somme = somme + lignesBegin[k] - lignesEnd[k];
}
if ( somme > 0 ) {
   err.ligneErr = -1;
   err.niveau = 2;
   strcpy(err.messageErr, "    - Il y a ");
   int2str(&(cInt[0]), somme);
   strcat(err.messageErr, cInt);
   strcat(err.messageErr, " 'end' manquant");
   if ( somme > 1 ) strcat(err.messageErr, "s");
   strcat(err.messageErr, " dans le script.");
   fwrite(&err, sizeof(ERREUR), 1, fLog);
}


/* Recherche des erreurs d'enchanement de test : dtection des endif en trop */
blocTests[0] = lignesIf[0] - lignesEndif[0];

for ( k = 1; k < nbLignes; k++ ) {
    blocTests[k] = blocTests[k-1] + lignesIf[k] - lignesEndif[k];
}

for ( k = 1; k < nbLignes; k++ ) {
    if ( blocTests[k] < 0 ) {
       err.ligneErr = k;
       err.niveau = 2;
       /* Dtection du bloc if/endif "matre" prcdent */
       debut = 0;
       fin = k;
       l = k-1;
       test = 0;
       while ( test == 0 ) {
             l--;
             if ( l < 0 ) test = 2;
             else {
                  if ( blocTests[l] == 0 ) {
                     test = 1;
                     debut = l+1;
                  }
             }
       }
       /* Copie de l'erreur dans le log d'erreur */
       debut++;
       fin++;
       strcpy(err.messageErr, "    - Ligne ");
       int2str(&(cInt[0]), fin);
       strcat(err.messageErr, cInt);
       strcat(err.messageErr, " : un 'endif' en trop ");
       if ( test == 2 ) strcat(err.messageErr, "(pas de 'if' avant le 'endif').");
       else {
            strcat(err.messageErr, "(l'erreur a probablement t faite entre la ligne ");
            int2str(&(cInt[0]), debut);
            strcat(err.messageErr, cInt);
            strcat(err.messageErr, " et la ligne ");
            int2str(&(cInt[0]), fin);
            strcat(err.messageErr, cInt);
            strcat(err.messageErr, ").");
       }
       fwrite(&err, sizeof(ERREUR), 1, fLog);
       /* Ajout de 1  toutes les valeurs de blocTests aprs k pour annuler l'effet du endif de trop */
       for (l = k+1; l < nbLignes; l++) {
           blocTests[l] = blocTests[l]+1;
       }
    }
}


/* Recherche des erreurs d'enchanement de test : dtection des if en trop */
for ( k = 0; k < nbLignes; k++ ) {
    somme = somme + lignesIf[k] - lignesEndif[k];
}
if ( somme > 0 ) {
   err.ligneErr = -1;
   err.niveau = 2;
   strcpy(err.messageErr, "    - Il y a ");
   int2str(&(cInt[0]), somme);
   strcat(err.messageErr, cInt);
   strcat(err.messageErr, " 'endif' manquant");
   if ( somme > 1 ) strcat(err.messageErr, "s");
   strcat(err.messageErr, " dans le script.");
   fwrite(&err, sizeof(ERREUR), 1, fLog);
}


/* Recherche des erreurs d'enchanement de test : dtection des else sans if avant */
for ( k = 0; k < nbLignes; k++ ) {
    if ( lignesElse[k] == 1 ) {
         somme = 0;
         test = 0;
         for ( l = k; l >= 0; l-- ) {
             somme = somme - lignesIf[l] + lignesEndif[l];
             if ( somme < 0 ) test = 1;
         }
         if ( test == 0 ) {
              err.ligneErr = k;
              err.niveau = 2;
              strcpy(err.messageErr, "    - Ligne ");
              int2str(&(cInt[0]), k+1);
              strcat(err.messageErr, cInt);
              strcat(err.messageErr, " : un 'else' sans 'if' avant.");
              fwrite(&err, sizeof(ERREUR), 1, fLog);
         }
    }
}


/* Recherche des erreurs d'enchanement de test : dtection des elseif sans if avant */
for ( k = 0; k < nbLignes; k++ ) {
    if ( lignesElseif[k] == 1 ) {
         somme = 0;
         test = 0;
         m = -1;
         for ( l = k; l >= 0; l-- ) {
             somme = somme - lignesIf[l] + lignesEndif[l];
             if ( somme < 0 ) {
                  test = 1;
                  if ( m < 0 ) m = l;
             }
         }
         if ( test == 0 ) {
              err.ligneErr = k;
              err.niveau = 2;
              strcpy(err.messageErr, "    - Ligne ");
              int2str(&(cInt[0]), k+1);
              strcat(err.messageErr, cInt);
              strcat(err.messageErr, " : un 'elseif' sans 'if' avant.");
              fwrite(&err, sizeof(ERREUR), 1, fLog);
         }
         debut = 1;
         if ( test == 1 ) {
              l = k;
              somme = 0;
              while ( ( l > m ) && ( debut == 1 ) && (somme >= 0 ) ) {
                  somme = somme - lignesIf[l] + lignesEndif[l];
                  if ( ( somme == 0 ) && ( lignesElse[l] == 1 ) ) {
                       debut = 0;
                  }
                  l--;
              }
         }
         if ( debut == 0 ) {
              err.ligneErr = k;
              err.niveau = 1;
              strcpy(err.messageErr, "    - Ligne ");
              int2str(&(cInt[0]), k+1);
              strcat(err.messageErr, cInt);   
              strcat(err.messageErr, " : alerte, un 'elseif' prcd d'un 'else' (situ  la ligne ");
              int2str(&(cInt[0]), l+2);
              strcat(err.messageErr, cInt);  
              strcat(err.messageErr, "). Le 'elseif' ne sera donc jamais execut !");
              fwrite(&err, sizeof(ERREUR), 1, fLog);              
         }
    }
}


/* Recherche des tests o plus de dix if sont imbriqus */
/*         ...pas  proprement parler une erreur, mais risque de faire n'importe quoi in game */
blocTests[0] = lignesIf[0] - lignesEndif[0];

for ( k = 1; k < nbLignes; k ++ ) {
    blocTests[k] = blocTests[k-1] + lignesIf[k] - lignesEndif[k];   
}

test = 0;
for ( k = 0; k < nbLignes; k ++ ) {
    if ( test == 0 ) {
       if ( blocTests[k] >= 10 ) {
          test = 1;
          debut = k;
       }
    }
    if ( test == 1 ) {
       if ( blocTests[k] < 10 ) {
          test = 0;
          fin = k;
          err.ligneErr = k;
          err.niveau = 1;
          strcpy(err.messageErr, "    - Alerte : plus de dix if imbriqus entre les lignes ");
          int2str(&(cInt[0]), debut);
          strcat(err.messageErr, cInt);
          strcat(err.messageErr, " et ");
          int2str(&(cInt[0]), fin);
          strcat(err.messageErr, cInt);
          strcat(err.messageErr, " (souvent mal interprt par le moteur du jeu).");
          fwrite(&err, sizeof(ERREUR), 1, fLog);
       }
    }
}

fclose(fLog);
return 0;

}
