#include "header.h"



/*------------------------------------------------------------------------------------------------*/
/* Fonction permettant de dtecter les if, endif, while et endwhile dans une chaine de caractres */
/*------------------------------------------------------------------------------------------------*/

void strDetectTest(int *ligneTest, int nbLignes, char ScNom[50], char testChar[9]) {

FILE *fScript;
char c;
int k, l, test;

fScript = fopen(ScNom, "rt");
if ( fScript == NULL ) {
   printf("Impossible d'ouvrir le fichier \"%s\" depuis le fichier source \"strDetectTest.cpp\"\n\n", ScNom);
   system("PAUSE");
   exit(1);
}

for ( k = 0; k < (nbLignes+1); k++ ) { // On parcourt toutes les lignes
    c = getc(fScript); // Acquisition lettre  lettre du script
    while ( ( typeChar(c) == 1 ) && ( c != ';' ) && ( c != '\n' ) && ( c != '\r') && ( c != EOF ) ) c = getc(fScript); // Tant que c'est un espace, on continue
    test = 1;
    if ( isalpha(c) == 1 ) c = tolower(c); // Si c'est une lettre, on la modifie en minuscule pour les comparaisons
    if ( c != testChar[0] ) test = 0; // Si le premier caractre n'est pas le mme que celui du test recherch, on ne fait rien pour cette ligne
    else { // Sinon...
         l = 1;
         while ( ( l < strlen(testChar) ) && ( c != '\n' ) && ( c != '\r' ) && ( c != EOF ) ) { // ... on compare pour les caractres suivants
               c = getc(fScript);
               if ( isalpha(c) == 1 ) c = tolower(c);
               if ( c != testChar[l] ) test = 0;
               l++;
         }
         if ( ( test == 1 ) && ( c != '\n' ) && ( c != '\r' ) && ( c != EOF ) ) { // Dernires vrications si on a trouv la bonne chane de caractres...
              c = getc(fScript);
              if ( ( typeChar(c) != 1 ) && ( c != EOF ) && ( c != '(' ) && ( c != ',' ) ) test = 0;
         }
    }
    while ( ( c != '\n' ) && ( c != '\r' ) && ( c != EOF ) ) c = getc(fScript); // N'arrive que si on a eu un ';' marquant un commentaire : dans ce cas, on va directement  la fin de la ligne
    *(ligneTest+k) = test; // On mmorise ce qu'on a trouv dans le vecteur (un = trouv, zro = non trouv)
}

fclose(fScript);

}
