#include "header.h"



/*------------------------------------------------------------------------------*/
/*             Script traitant les ventuelles erreurs de if/while              */
/*------------------------------------------------------------------------------*/

int mainMEF(char ScNom[50]) {

FILE *fScript;
int SizeScript=0, nbLignes=1, compteur=0, k=0, changeNbTab, l, m, test=0, debut, fin, somme=0, SizeLigne, var, nbTab[5000], lignesIf[5000], lignesEndif[5000], lignesElse[5000], lignesElseif[5000], blocTests[5000];
char *texteScript, c, *ligne, *ligneCode, cInt[7];

//------------------------------------------------------------------------------
//                       Acquisition du texte du script                         
//------------------------------------------------------------------------------

fScript = fopen(ScNom, "rt");

// Message si le fichier contenant le script est impossible  ouvrir.
if ( fScript == NULL ) {
   return 2;
}

// Recherche de la longueur du texte cod et allocation dynamique de mmoire selon cette longueur
while ( getc(fScript) != EOF ) {
      SizeScript++;
}
rewind(fScript);

texteScript = (char*)malloc((SizeScript+1)*sizeof(char));

// Remplissage de la chane de caractres texteScript par le script contenu dans le fichier
compteur = 1;
while( (c=getc(fScript)) != EOF ) {
       texteScript[k] = c;
       if ( c == '\n' ) compteur++;
       k++;
}
texteScript[k] = '\0';
fclose(fScript);



//------------------------------------------------------------------------------
//                  Recherche du nombre de lignes dans le texte                 
//------------------------------------------------------------------------------

// Recherche du nombre de retours charriot dans le script (correspond au nombre de lignes-1 car la premire ligne n'est pas prcde par un retour charriot)
for ( k = 0; k < SizeScript; k++ ) {
    if ( texteScript[k] == '\n' ) nbLignes++;
}
if ( nbLignes > 5000 ) return 3;


strDetectTest(lignesIf, nbLignes, ScNom, "if");
strDetectTest(lignesEndif, nbLignes, ScNom, "endif");
strDetectTest(lignesElse, nbLignes, ScNom, "else");
strDetectTest(lignesElseif, nbLignes, ScNom, "elseif");

// Recherche des erreurs d'enchanement de test : dtection des endif en trop
blocTests[0] = lignesIf[0] - lignesEndif[0];

for ( k = 1; k < nbLignes; k++ ) {
    blocTests[k] = blocTests[k-1] + lignesIf[k] - lignesEndif[k];
}

for ( k = 1; k < nbLignes; k++ ) {
    if ( blocTests[k] < 0 ) return 0;
}


// Recherche des erreurs d'enchanement de test : dtection des if en trop
for ( k = 0; k < nbLignes; k++ ) {
    somme = somme + lignesIf[k] - lignesEndif[k];
}
if ( somme > 0 ) return 0;


// Recherche des erreurs d'enchanement de test : dtection des else sans if avant
for ( k = 0; k < nbLignes; k++ ) {
    if ( lignesElse[k] == 1 ) {
         somme = 0;
         test = 0;
         for ( l = k; l >= 0; l-- ) {
             somme = somme - lignesIf[l] + lignesEndif[l];
             if ( somme < 0 ) test = 1;
         }
         if ( test == 0 ) return 0;
    }
}


// Recherche des erreurs d'enchanement de test : dtection des elseif sans if avant
for ( k = 0; k < nbLignes; k++ ) {
    if ( lignesElseif[k] == 1 ) {
         somme = 0;
         test = 0;
         m = -1;
         for ( l = k; l >= 0; l-- ) {
             somme = somme - lignesIf[l] + lignesEndif[l];
             if ( somme < 0 ) {
                  test = 1;
                  if ( m < 0 ) m = l;
             }
         }
         if ( test == 0 ) return 0;
    }
}




for ( k = 0; k < 5000; k++ ) nbTab[k] = 0;

for ( k = 1; k < nbLignes; k++ ) {
    changeNbTab = lignesIf[k-1] - lignesEndif[k];
    nbTab[k] = nbTab[k-1] + changeNbTab;
}

for ( k = 0; k < nbLignes; k++ ) {
    if ( ( lignesElse[k] != 0 ) || ( lignesElseif[k] != 0 ) ) nbTab[k] = nbTab[k] - 1;
}

for ( k = 0; k < nbLignes; k++ ) {
    if ( nbTab[k] < 0 ) return 0;
}

remove(ScNom);

fScript = fopen(ScNom, "wt");

compteur = 0;
m = 0;
while ( compteur < SizeScript ) {
      // Retrait de tous les espaces initiaux
      k = 0;
      while ( isspace(texteScript[compteur]) != 0 ) {
            if ( texteScript[compteur] == '\n' ) {
                 putc('\n', fScript);
                 if ( compteur > 0 ) {
                    if ( texteScript[compteur-1] == '\n' ) m++;
                    else {
                         int compteur2 = compteur;
                         int testCompteur2 = 1;
                         while ( testCompteur2 ) {
                               compteur2--;
                               if ( compteur2 < 0 ) testCompteur2 = 0;
                               else {
                                    if ( isspace(texteScript[compteur2]) == 0 ) testCompteur2 = 0;
                                    else {
                                         if ( texteScript[compteur2] == '\n' ) {
                                              m++;
                                              testCompteur2 = 0;
                                         }
                                    }
                               }
                         }
                    }
                 }
            }
            compteur++;
      }
      // Ajout du bon nombre de tabulations
      if ( texteScript[compteur] != '\n' ) {
           l = 0;
           while ( l < nbTab[m] ) {
                 putc('\t', fScript);
                 l++;
           }
      }
      // Ajout du texte de la ligne en cours et mise en forme des parenthses
      while ( ( texteScript[compteur] != '\n' ) && ( compteur < SizeScript ) ) {
            l = 0;
            if ( ( texteScript[compteur] == '(' ) || ( texteScript[compteur] == ')' ) ) {
                 if ( compteur > 0 ) {
                      if ( ( texteScript[compteur-1] != ' ' ) && ( texteScript[compteur-1] != '\t' ) && ( texteScript[compteur-1] != '\n' ) ) putc(' ', fScript);
                 }
                 if ( compteur < ( strlen(texteScript) - 1 ) ) {
                      if ( ( texteScript[compteur+1] != ' ' ) && ( texteScript[compteur+1] != '\t' ) && ( texteScript[compteur+1] != '\n' ) ) l = 1;
                 }
            }
            putc(texteScript[compteur], fScript);
            if ( l == 1 ) putc(' ', fScript);
            compteur++;
      }
      m++;
}

free(texteScript);
fclose(fScript);

return 1;

}
